--
-- The Tags Package
--
-- @author Michael Steigman (michael@steigman.net)
-- @creation-date 2008-05-28
--

create table tags (
        tag_id 		integer
                        constraint tags_tag_id_pk
			primary key,
        tag_text	varchar(100) not null,
        locale 		varchar(5) not null
                        constraint tags_trans_locale_fk
                        references ad_locales,
        type		varchar(50),
        created 	timestamptz default current_timestamp,
        last_used 	timestamptz
);

create table tagged_objects (
	user_id 	integer
			constraint to_tagged_user_id_fk
			references acs_objects
			on delete cascade,
	tag_id  	integer
			constraint to_tag_id_fk
			references tags
			on delete cascade,
	object_id 	integer
			constraint to_tagged_object_id_fk
	                references acs_objects
			on delete cascade,
	tagged_on	timestamptz,
	primary key (user_id, tag_id, object_id)
);

create index to_user_tag_idx on tagged_objects (user_id, tag_id);
create index to_object_tag_idx on tagged_objects (object_id, tag_id);
create index to_object_idx on tagged_objects (object_id);

-- STAT TABLE
-- create table tag_stats (
-- 	user_id integer constraint ts_user_id_fk
--         	        references users
-- 			on delete cascade,
-- 	tag_id  integer constraint ts_tag_id_fk
--         	        references tags
-- 			on delete cascade,
-- 	count integer
-- 	primary key (user_id, tag_id)
-- )

-- create table tag_bundles (
-- bundle_id
-- object_id -- usually user_id but perhaps community_id?
-- bundle_name
-- )

-- create table bundled_tags (
-- tag_id
-- bundle_id
-- timestamptz
-- )

-- -- per package (subsite?) category to tag mapping
-- create table categorized_tags (
-- tag_id
-- category_id
-- category_tree_id
-- package_id
-- )

-- FOR FUTURE USE, IF NEC.
-- helper tables for speed; maintained by triggers on tagged_objects
-- create table user_tags (
-- user_id
-- tag_id
-- )

-- create table object_tags (
-- object_id
-- tag_id
-- )
